from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import string
import os

 
class ShadowImage(Sensor):


	def __init__(self):

		global _; _ = i18n.Translator("Shadowimage-Sensor")
		global __img_history__

		self.__output = ""
		Sensor.__init__(self)
		self._set_config_type("imageHistory", TYPE_STRING, ";".join(["gfx/default.jpg"]) )
		self._set_config_type("imagePos", TYPE_INT, 0)
		self._add_timer(1000, self.__update )

	def strip(self, fileUri):
		fucker=string.lstrip(fileUri, "[\'file://")
		fucker="/"+string.rstrip(fucker, "\']")
		return fucker

	def updateDisplay(self, da_img):
		data = self._new_output()
		if os.path.isfile(da_img) :
			data.set("img", da_img)
		else :
			data.set("img", "gfx/default.jpg")
		self._send_output(data)
		return 0

	def addimg(self, file):
		__img_history__ = self._get_config("imageHistory").split(";")
		__posInList__ = self._get_config("imagePos")

		__img_history__.append(file)
		__posInList__=len(__img_history__)-1
		self.updateDisplay( __img_history__[__posInList__] )

		self._set_config("imageHistory", ";".join(__img_history__ ) )
		self._set_config("imagePos", __posInList__)
		return 0
	
	def delimg(self, oooga):
		__img_history__ = self._get_config("imageHistory").split(";")
		__posInList__ = self._get_config("imagePos")

		if len(__img_history__) != 1 :
			del __img_history__[__posInList__]
		if __posInList__ == len(__img_history__ ) :
			__posInList__=__posInList__-1
		self.updateDisplay( __img_history__[__posInList__] )

		self._set_config("imageHistory", ";".join(__img_history__ ) )
		self._set_config("imagePos", __posInList__)
		return 0

	def moveDown(self, booga):
		__img_history__ = self._get_config("imageHistory").split(";")
		__posInList__ = self._get_config("imagePos")

		if __posInList__ == len(__img_history__)-1 :
			__posInList__=0
		else :
			__posInList__=__posInList__+1
		self.updateDisplay( __img_history__[__posInList__] )

		self._set_config("imagePos", __posInList__)
		return 0

	def moveUp(self, booga):
		__img_history__ = self._get_config("imageHistory").split(";")
		__posInList__ = self._get_config("imagePos")

		if __posInList__ == 0 :
			__posInList__ = len(__img_history__)-1
		else :
			__posInList__=__posInList__-1
		self.updateDisplay( __img_history__[__posInList__] )

		self._set_config("imagePos", __posInList__)
		return 0

	def call_action(self, call, path, args = []):
		if call == "__drag_n_drop" :
			mofo = self.strip(args[0][0])
			self.addimg(mofo)
		if call == "da_menu" :
			self._open_menu([ (_("_Next image"), 1, None, self.moveDown, []), (_("_Previous image"), 1, None, self.moveUp, []), (_("Re_move image"), 1, None, self.delimg, []) ] )
		if args[0] == 1 :
			self.moveDown(0)
		if args[0] == 0 :
			self.moveUp(0)
		return 0

	def __update(self):
		
		data = self._new_output()
		count = self._get_config("imagePos")
		theImage = self._get_config("imageHistory").split(";")
		data.set("img", theImage[count])
		self._send_output(data)
		return 0


def new_sensor(args): return apply(ShadowImage, args)
